import { bsv } from "scryptlib";
export declare type version = {
    identifier: string;
    version: string;
    args: string[];
    argPos: number;
    md5: string;
    options: any;
    length: number;
};
export declare type marketVersion = version & {
    options: {
        devFee: number;
        maxOptionCount: number;
        maxOracleCount: number;
        developerPayoutAddress: string;
    };
};
export declare const marketContracts: {
    [indentifier: string]: marketVersion;
};
export declare const currentMarketContract: marketVersion;
export declare const oracleContracts: {
    [indentifier: string]: version;
};
export declare const currentOracleContract: version;
export declare function getArgPos(version: version, argument: string): number;
export declare function getMd5(script: bsv.Script, length: number, argPos: number, argLength: number): string;
export declare function getInfo(scryptJSON: any, argPos: number, argLength: number): {
    md5: string;
    length: number;
    identifier: any;
};
